/*
	Load informations
	By Xavier Bonnafous
	under GPL
*/

#include <stdio.h>
#include <mach/processor_info.h>
#include <mach.h>
		
int main ()
{
	kern_return_t kr;
	
	host_t *Myhost;
	*Myhost = mach_host_self();
	
	
	processor_set_t pset;
	processor_set_name_array_t *pname;
	mach_msg_type_number_t *pcount;
	
	kr = host_processor_sets(*Myhost,pname,pcount);
	
	printf("Processor set by XA \n");
	
	int err;
	err = thread_get_assignment(mach_thread_self(),&pset);
	
	
	int flavor = PROCESSOR_SET_BASIC_INFO;
		
	processor_set_basic_info_t Myinfo;
	processor_set_info_t info;
	info=(processor_set_info_t)Myinfo;
		
	natural_t *count;
	*count=PROCESSOR_BASIC_INFO_COUNT;
	
		
	int data;
	kr = processor_set_info(
		pset,
		flavor,
		Myhost,
		info,
		count);

	data = Myinfo->processor_count;
	printf("nb processors %i \n",data);
	
	data = Myinfo->task_count;
	printf("nb task %i \n",data);
	
	data = Myinfo->thread_count;
	printf("nb thread %i \n",data);
	
	data = Myinfo->load_average;
	printf("load %i \n",data);
	
	data = Myinfo->mach_factor;
	printf("mach factor %i \n",data);
	

	
	return (0);
}
